// ADC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "aiowdm.h"




int _tmain(int argc, _TCHAR* argv[])
{

  unsigned char CardNum = 0;
  unsigned char JumperData;
  unsigned char Channels;
  unsigned char CH;
  unsigned short ADData;
  unsigned Scan = 0;
  double V;

  RelOutPortB(CardNum, 0x1B, 0); // reset card

  JumperData = RelInPortB(CardNum, 0x12);
  if ((JumperData & 0x02) != 0)
    Channels = 16;
  else
    Channels = 8;

  RelOutPort(CardNum, 0x2, 0x0000);                     // configure channel gains (ch 0-7)
  RelOutPort(CardNum, 0x4, 0x0000);                     // configure channel gains (ch 8-15)
  RelOutPortB(CardNum, 0x6, 0x10 * (Channels - 1));     // configure start->end scan range
  RelOutPortB(CardNum, 0x7, 0x0);                       // configure 0 oversamples
  // configure counter timers here, if (you'll be using CTR timed conversions
  //
  RelOutPortB(CardNum, 0x11, 0x14);                     // software start, a scan at a time
  // RelOutPortB(CardNum, 0x11, 0x16);                  // timer start, a scan at a time
  // RelOutPortB(CardNum, 0x11, 0x15);                  // external start, a scan at a time
	
  
  
  do{
	  printf("Starting scan %d\n\r", Scan); 
	  RelOutPortB(CardNum, 0x1, 0x00);    // software start a conversion scan
	  CH = 0;
	  do{
		if ((RelInPortB(CardNum, 0x12) & 0x20) != 0) {
		  ADData = RelInPort(CardNum, 0x0);
		  V = ADData / 65535.0;
		  if ((JumperData & 0x01) != 0) V = V - 0.5;
		  if ((JumperData & 0x04) == 0) V = V * 2;
		  V = V * 10;

		  printf("CH %2hd = %2.5lf Volts\n\r", CH, V);
		  CH++;
		}
	  } while (CH < Channels); 
	  Scan++;

  }while(1);	
	
  return 0;
}
